package com.tzld.piaoquan.recommend.feature.grpcservice;

import com.tzld.piaoquan.recommend.feature.client.ProtobufUtils;
import com.tzld.piaoquan.recommend.feature.model.feature.*;
import com.tzld.piaoquan.recommend.feature.service.AdItemFeatureService;
import com.tzld.piaoquan.recommend.feature.service.UserAdFeatureService;
import com.tzld.piaoquan.recommend.feature.service.UserFeatureService;
import com.tzld.piaoquan.recommend.feature.service.VideoFeatureService;
import io.grpc.stub.StreamObserver;
import lombok.extern.slf4j.Slf4j;
import net.devh.boot.grpc.server.service.GrpcService;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @author dyp
 */
@GrpcService
@Slf4j
public class FeatureGrpcService extends FeatureServiceGrpc.FeatureServiceImplBase {
    @Autowired
    private UserFeatureService userFeatureService;
    @Autowired
    private VideoFeatureService videoFeatureService;

    @Autowired
    private AdItemFeatureService adItemFeatureService;

    @Autowired
    private UserAdFeatureService userAdFeatureService;


    @Override
    public void getUserFeature(GetUserFeatureRequest request, StreamObserver<GetUserFeatureResponse> responseObserver) {
        log.info("FeatureGrpcService getUserFeature request={}", ProtobufUtils.toJson(request));
        GetUserFeatureResponse response = userFeatureService.getUserFeature(request);
        log.info("FeatureGrpcService getUserFeature response={}", ProtobufUtils.toJson(response));
        responseObserver.onNext(response);
        responseObserver.onCompleted();
    }

    @Override
    public void getVideoFeature(GetVideoFeatureRequest request,
                                StreamObserver<GetVideoFeatureResponse> responseObserver) {
        log.info("FeatureGrpcService getVideoFeature request={}", ProtobufUtils.toJson(request));
        GetVideoFeatureResponse response = videoFeatureService.getVideoFeature(request);
        log.info("FeatureGrpcService getVideoFeature response={}", ProtobufUtils.toJson(response));
        responseObserver.onNext(response);
        responseObserver.onCompleted();
    }

    @Override
    public void getAllVideoFeature(GetAllVideoFeatureRequest request,
                                   StreamObserver<GetAllVideoFeatureResponse> responseObserver) {
        log.info("FeatureGrpcService getAllVideoFeature request={}", ProtobufUtils.toJson(request));
        GetAllVideoFeatureResponse response = videoFeatureService.getAllVideoFeature(request);
        log.info("FeatureGrpcService getAllVideoFeature response={}", ProtobufUtils.toJson(response));
        responseObserver.onNext(response);
        responseObserver.onCompleted();
    }

    @Override
    public void getUserAdFeature(GetUserAdFeatureRequest request,
                                   StreamObserver<GetUserAdFeatureResponse> responseObserver) {
        log.info("FeatureGrpcService getUserAdFeature request={}", ProtobufUtils.toJson(request));
        GetUserAdFeatureResponse response = userAdFeatureService.getUserAdFeature(request);
        log.info("FeatureGrpcService getUserAdFeature response={}", ProtobufUtils.toJson(response));
        responseObserver.onNext(response);
        responseObserver.onCompleted();
    }

    @Override
    public void getAdItemFeature(GetAdItemFeatureRequest request,
                                 StreamObserver<GetAdItemFeatureResponse> responseObserver) {
        log.info("FeatureGrpcService getAdItemFeatureRequest request={}", ProtobufUtils.toJson(request));
        GetAdItemFeatureResponse response = adItemFeatureService.getAdItemFeature(request);
        log.info("FeatureGrpcService getAdItemFeatureRequest response={}", ProtobufUtils.toJson(response));
        responseObserver.onNext(response);
        responseObserver.onCompleted();
    }

    @Override
    public void getAllAdItemFeature(GetAllAdItemFeatureRequest request,
                                 StreamObserver<GetAllAdItemFeatureResponse> responseObserver) {
        log.info("FeatureGrpcService getAllAdItemFeature request={}", ProtobufUtils.toJson(request));
        GetAllAdItemFeatureResponse response = adItemFeatureService.getAllAdItemFeature(request);
        log.info("FeatureGrpcService getAllAdItemFeature response={}", ProtobufUtils.toJson(response));
        responseObserver.onNext(response);
        responseObserver.onCompleted();
    }
}
